;Animation Studio v0.1b by Levi Lansing - puzzlesome@hotmail.com
;***************************************************************
;included asm files:
;
;main.asm
;routelib.asm
;gray.asm
;
;
;this project is incomplete!
;I allow no stealing of anything without credit to the author
;if you wish to use large portions of this program, please
;ask for permission first!
;
;credits:
;  the search routine for searching of pics was adapted from
;  a routine used for searching for strings written for me by
;  Andreas Finne -- Thank you Andreas!!!
;  (i hope i spelled your name right, i don't have it on hand)



#include "ti86asm.inc"

TableOfStrings = _plotSScreen
_get_word_ahl	equ		521Dh
_jforcecmdnochar	.EQU	409Ch

.org _asm_exec_ram
	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

ShellTitle:
	.db "Animation Studio 0.1b",0

ProgStart:
	ld (Stack),SP
	call _runindicoff
	call _flushallmenus
	call _clrScrn
	ld hl,($D28D)
	ld de,$0064
	add hl,de
	ld (ABS_MEM_START),hl
	ld de,$8000
	add hl,de
	push hl
	ld (MEM_START),hl		;where the OPS ends
	ld hl,($D291)		;Floating Point Stack
	ld de,$7F9C
	and a
	add hl,de
	ld (MEM_END),hl	;where the FPS ends (where AniStd will start using mem)
	pop de
	and a
	sbc hl,de
	ld (FREE_MEM),hl	;free space between OPS and FPS
;	push hl
;	xor a
;	call _dispAHL
;	call _getkey
;	pop hl
	ld a,4
	sub h
    jp nc,NotEnoughMEM
	ld de,open
	call decompV
	set textInverse,(iy+textflags)
	ld de,$000B
	ld (_penCol),de
	ld hl,LDpicsTEXT
	call _vputs
	res textInverse,(iy+textflags)

	ld de,$0A0C
	ld (_penCol),de

Search:
	xor a
	ld (NumberOfStrings),a
	ld ix,TableOfStrings;Point ix to a place were the addresses of the strings are going to be stored
	call _ram_page_7	;This will load RAM page #7 in the area between $8000 and $BFFF
						;RAM page 7 contains the VAT (variable allocation table, or something like that)
						;Here are the addresses of all the variables on the calc stored.
						;It's written backwards so the first entry is at $BFFF.

	ld hl,$BFFF		;We want to start searching at the beginning (top/bottom) of the VAT.
	ld d,h			;Copy it to de
	ld e,l			;We could use 'ld de,$BFFF' but it's one byte longer and takes 2 more clock cycles

	ld bc,($D298)	;$D298 contains the address to the end (bottom/top) of the VAT.
	and a			;Clear the carry flag
	sbc hl,bc		;Subtract the bottom from the top to get the length. hl = length of VAT
	ld b,h			;Copy the result to bc
	ld c,l
	ex de,hl		;Exchange hl and de (hl=$BFFF)
	ld de,DATA
	push de

SearchLoopA:
	ld a,$11		;We are looking for pics. $11 is the ID byte for pics.

SearchLoopB:
	cpdr		;This instruction does this: cp (hl)/dec hl/dec bc, i.e. compares the value pointed to by
				;hl with 'a' decreases hl and bc. It continues doing this until a=(hl) or bc=0.
	jp po,DoneSearching		;Parity is odd when bc=0

		;When we've come this far we have found a string. Now we're going to check whether it's one
		;of our strings.

	push hl			;Then we save the values so we can continue to search where we left off.
	push bc

	ld e,(hl)		;Load the LSB of the ABS address to e
	dec hl			;hl now points to the middle byte in the address
	ld d,(hl)		;Load it into d
	dec hl			;hl points to MSB of the address
	ld a,(hl)		;Load it into a
					;Now we have the address in ade, but the rom routines use ahl so...

;	ex de,hl			;exchange de and hl. AHL = address to the string variable
;	call _inc_ptr_ahl	;Skip the sign bytes of the string
;	call _inc_ptr_ahl

			;***Yes, we have found a WW2BAM string. Now we save the address to the data

	ld (ix),d			;Store the address to the pic
	ld (ix+1),e
	ld (ix+2),a
	inc ix				;Make ix point to empty space.
	inc ix
	inc ix

	ld a,(NumberOfStrings)		;inc the # of strings found
	inc a
	ld (NumberOfStrings),a

	pop bc
	pop hl
	pop de
	dec hl
	dec bc
	dec hl
	dec bc
	dec hl
	dec bc
	dec hl
	dec bc
	push bc
	push hl
	ld b,(hl)		;len of string name -> b
	ld a,9
	sub b
	ld c,a
NameLoop:
	dec hl
	ld a,(hl)
	ld (de),a
	inc de
	djnz NameLoop
	ld b,c
SpaceLoop:
	xor a
	ld (de),a
	inc de
	djnz SpaceLoop
	pop hl
	pop bc
	push de
	xor a
	cp c
	jp nz,SearchLoopA	;continue search
	cp b
	jp nz,SearchLoopA	;continue search



DoneSearching:
	pop de
	ld (numbering),de
	xor a
	ld (numSelected),a
	ld a,(NumberOfStrings)
	ex de,hl
	ld b,a
	cp 0
	jr z,noDisplayQS
ClearNumbering:
	ld (hl),32
	inc hl
	djnz ClearNumbering
	jr DisplayQS
noDisplayQS:
	ld hl,NoStrings
	call _vputs
	call _getkey
	call _clrScrn
	ret
DisplayQS:
	call _ram_page_1

	ld a,1
	ld (HighlightPOS),a			;for later...
	ld (FirstDisplayed),a
	ld c,a
	ld a,47
	ld (currentNumber),a

	ld hl,DATA
	ld a,(NumberOfStrings)
	ld b,a
DTLoop:
	push bc
	push hl
	call _vputs
	ld b,c
	ld a,(HighlightPOS)
	add a,b
	dec a
	ld b,a
	ld hl,(numbering)
	dec hl
FindNumberA:
	inc hl
	djnz FindNumberA
	ld a,3
	ld (_penCol),a
	ld a,(hl)
	call _vputmap

	pop hl
	pop bc				;counter of tot # of strings
	ld de,9
	add hl,de
	ld a,$0C
	ld (_penCol),a
	ld a,(_penRow)
	add a,6
	ld (_penRow),a
	cp 57
	jr nc,OutOfRoom
	inc c
	djnz DTLoop

OutOfRoom:
	ld a,(HighlightPOS)
	call DrawHiLite

GetMenuKeys:
	call _getky
	cp K_UP
	jr z,UPH
	cp K_DOWN
	jr z,DPH
	cp K_ENTER
	jp z,Create
	cp K_SECOND
	jp z,Selected
	cp K_EXIT
	jp z,Exit
	cp K_CLEAR
	jp z,Exit
	call SoftDelay
	jr GetMenuKeys

	call _getkey
	call _clrScrn
	ret

DPH:
	ld hl,HighlightPOS		;where the highlighter is
	ld a,(hl)
	inc a
	ld b,a
	ld a,(FirstDisplayed)	;the # of the 1st displayed title
	ld c,a
	dec a
	add a,b
	ld d,a
	ld a,(NumberOfStrings)
	inc a
	cp d
	jr z,GetMenuKeys
	ld a,b
	ld (hl),a
	cp 9
	jr z,ScrollDown
	ld a,b
	dec a
	call DrawHiLite
	inc a
	call DrawHiLite
	jr GetMenuKeys

UPH:
	ld hl,HighlightPOS
	ld a,(hl)
	dec a
	jr z,ScrollUp
	ld (hl),a
	inc a
	call DrawHiLite
	dec a
	call DrawHiLite
	jr GetMenuKeys


ScrollUp:
	ld a,(FirstDisplayed)
	dec a
	jr z,GetMenuKeys
	ld (FirstDisplayed),a
	ld c,a
	dec a
	ld b,a					;\
	rla						; \
	rla						;  \_  a*9 -> b
	rla						;  /
	add a,b					; /
	ld b,a					;/
	ld hl,DATA
	xor a
	cp b
	jr z,ixok
SDfindStartIX:
	inc hl
	djnz SDfindStartIX
ixok:
	ld a,1
	ld b,a
	push bc
	push hl
	call DrawHiLite			;remove highlight
	ld de,$0A0C
	ld (_penCol),de

	ld hl,$FF3F
	ld de,$FF9F
	ld bc,656
	lddr

	ld hl,$FCA0
	ld de,$FCB0
	ld bc,80
	ldir

	pop hl
	pop bc
	jp DTLoop


ScrollDown:
	dec (hl)
	ld a,c
	inc a
	ld (FirstDisplayed),a
	ld c,a
	add a,6
	ld b,a					;\
	rla						; \
	rla						;  \_  a*9 -> b
	rla						;  /
	add a,b					; /
	ld b,a					;/
	ld hl,DATA
SDfindStartIX2:
	inc hl
	djnz SDfindStartIX2
	ld b,1
	push bc
	push hl
	ld a,8
	call DrawHiLite			;remove highlight
	ld de,$340C
	ld (_penCol),de

	ld hl,$FD10
	ld de,$FCB0
	ld bc,656
	ldir

	ld hl,$FF40
	ld de,$FF50
	ld bc,80
	ldir
	
	pop hl
	pop bc
	jp DTLoop


SoftDelay:		;the "soft delay" is just a battery saver by halting the CPU 10x
	ld b,10
SDL:
	HALT
	djnz SDL
	ret

SoftDelayx2:		;the "soft delay" is just a battery saver by halting the CPU 10x
	ld b,20
SDL2:
	HALT
	djnz SDL2
	ret

Selected:
	ld hl,HighlightPOS
	ld a,(hl)
	ld b,a
	push bc
	dec hl
	add a,(hl)
	dec a
	ld b,a
	ld hl,(numbering)
	dec hl
FindNumber:
	inc hl
	djnz FindNumber
	ld a,32
	cp (hl)
	jr nz,eraseNum
	call incCurNum
	ld (hl),a
	ld a,(numSelected)
	inc a
	ld (numSelected),a
	set textInverse,(iy+textflags)
	ld a,$03
	ld (_penCol),a
	ld a,$04
	pop bc
findRow:
	add a,6
	djnz findRow
	ld (_penRow),a
	ld a,(currentNumber)
	call _vputmap
	res textInverse,(iy+textflags)
	jp GetMenuKeys

incCurNum:		;call this- it incs the currentNumber skiping through the chars and returns
				;the current number in a
	ld a,(currentNumber)
	inc a
	cp 58
	jr nz,not58
	ld a,65
	jr nOK
not58:
	cp 91
	jr nz,not91
	ld a,97
	jr nOK
not91:
	cp 123
	jr nz,nOK
	ld a,128
	jr nOK
nOK:
	ld (currentNumber),a
	ret

eraseNum:
	jp GetMenuKeys
	ld c,(hl)
	ld (hl),32
	ld a,(NumberOfStrings)
	ld b,a
	ld hl,(numbering)
ReduceLoop:
	ld a,c
	cp (hl)
	jr nc,contRL
	ld a,(hl)
	call decNum
	ld (hl),a
contRL:
	inc hl
	djnz ReduceLoop
	ld hl,currentNumber
	ld a,(hl)
	call decNum
	ld (hl),a
	ld hl,numSelected
	dec (hl)
	ld de,open
	call decompV
	set textInverse,(iy+textflags)
	ld de,$000B
	ld (_penCol),de
	ld hl,LDpicsTEXT
	call _vputs
	res textInverse,(iy+textflags)
	ld de,$0A0C
	ld (_penCol),de

	ld a,(FirstDisplayed)
	ld c,a
	ld b,a					;\
	rla						; \
	rla						;  \_  a*9 -> b
	rla						;  /
	add a,b					; /
	ld b,a					;/
	ld hl,DATA-9
SDfindStartIX3:
	inc hl
	djnz SDfindStartIX3

	ld a,(NumberOfStrings)
	ld b,a
	jp DTLoop

decNum:			;call this to dec the pic num skiping through the chars and returns
				;the number in a
	dec a
	cp 64
	jr nz,not64
	ld a,57
	ret
not64:
	cp 96
	jr nz,not96
	ld a,90
	ret
not96:
	cp 127
	ret nz
	ld a,122
	ret


noneSelected:
	jp GetMenuKeys

Create:
	ld hl,$F600
	ld (Temp),hl
	ld a,(numSelected)
	cp 0
	jr z,noneSelected
	ld b,a
	ld a,'0'				;48
	ld (currentNumber),a
GetInOrderLoop:
	push bc
	ld a,(NumberOfStrings)
	ld b,a
	ld c,a
	ld a,(currentNumber)
	ld hl,(numbering)
FindCurNum:
	cp (hl)
	jr z,foundnum
	inc hl
	djnz FindCurNum

foundnum:
	ld a,c
	sub b
	inc a
	ld b,a
	ld ix,TableOfStrings-3
incix:
	inc ix
	inc ix
	inc ix
	djnz incix
	ld hl,(Temp)	;$F600+x -- where we're keeping the abs addr to the sel pics
	ld a,(ix)		;save abs addr...
	ld (hl),a
	inc hl
	ld a,(ix+1)
	ld (hl),a
	inc hl
	ld a,(ix+2)
	ld (hl),a
	inc hl
	ld (Temp),hl	;save data pos
	call incCurNum
	pop bc
	djnz GetInOrderLoop		;loop until we have them all copied

	ld a,(numSelected)
	ld b,a
	ld de,0
countLoop:
	inc de
	inc de
	inc de
	djnz countLoop

	ld b,d
	ld c,e
	ld hl,$F600
	ld de,DATA
	ldir

	ld (numbering),de		;numbering now holds the end of the used DATA
	ex de,hl
	ld e,$32				;50
	ld a,(numSelected)
	ld b,a
delay#s:
	ld (hl),e
	inc hl
	ld (hl),0
	inc hl
	djnz delay#s



#include "main.asm"

	jp Exit


#include "routelib.asm"
#include "gray.asm"

Load_RAM_p1:
	ld a,1
	ld hl,0
	call _load_ram_ahl
	ret


NotEnoughMEM:
	call _homeup
	ld hl,NEMEM
	call _puts
	ret
Exit:
	call _clrScrn
	call _homeup
	set graphdraw,(iy+graphflags)
	ld SP,(Stack)
	;ret
	jp _jforcecmdnochar

DrawHiLite:
	push af
	ld hl,$FC00
	ld de,$0010
	ld b,a
	ld a,4
DHL_incY:
	add a,6
	djnz DHL_incY
	ld b,a
AdvHL:
	add hl,de
	djnz AdvHL
	ld b,7
HLloop1:
	push bc
	ld a,%00111111
	xor (hl)
	ld (hl),a
	inc hl
	ld b,14
HLloop2:
	ld a,$FF
	xor (hl)
	ld (hl),a
	inc hl
	djnz HLloop2
	ld a,%11111100
	xor (hl)
	ld (hl),a
	inc hl
	pop bc
	djnz HLloop1
	pop af
	ret

NumberOfStrings:
	.db 0
FirstDisplayed:
	.db 0
HighlightPOS:
	.db 0
currentNumber:
	.db 0
numbering:
	.db 0,0
numSelected:
	.db 0
Temp:
	.dw 0
Temp2:
	.dw 0
MEM_START:
	.dw 0
ABS_MEM_START:
	.dw 0
MEM_END:
	.dw 0
FREE_MEM:
	.dw 0
Stack:
	.dw 0
NoStrings:
	.db "< No  pictures  present >",0
LDpicsTEXT:
	.db "New  Animation:  Select  Pictures",0
NEMEM:
	.db "-Not Enough Free MEM-"
	.db "Exit all shells and  "
	.db "try again. If problem"
	.db "persists, reset calc "
	.db "and try again.",0


open:
;Compressed picture made with BMP2ASM by Levi Lansing (puzzlesome@hotmail.com)
;Compressed from 1024 bytes to 118 bytes - 88% compressed!
  .db $0F, $3F, $7F, $EF, $CF, $9F, $BF, $F0, $E0, $B7, $C0, $33, $E0, $78, $3F, $0F
  .db $B7, $FF, $07, $B7, $00, $37, $B7, $FF, $09, $B7, $00, $37, $B7, $FF, $09, $B7
  .db $00, $37, $B7, $FF, $09, $B7, $00, $37, $B7, $FF, $09, $B7, $00, $37, $B7, $FF
  .db $09, $B7, $00, $37, $B7, $FF, $09, $B7, $00, $37, $B7, $FF, $09, $B7, $00, $37
  .db $B7, $FF, $09, $B7, $00, $37, $B7, $FF, $09, $B7, $00, $37, $B7, $FF, $09, $B7
  .db $00, $37, $B7, $FF, $09, $B7, $00, $37, $B7, $FF, $09, $B7, $00, $37, $B7, $FF
  .db $09, $B7, $00, $37, $FF, $FF, $F0, $FC, $FE, $F7, $F3, $F9, $FD, $0F, $07, $B7
  .db $03, $33, $07, $1E, $FC, $F0


DATA:
.end
