#define _user_int_ram    $D2FD
;--grayscale and picture resizing library--

; white located at neither
; light gray located at $F600
; dark gray located at $FC00
; black located at both


Make25%prev:
  di
  ld a,$3C			;norm video screen
  out (0),a
  ld a,%11000000
  ld (bits),a
  ld a,%10000000
  ld (bits+1),a
  ld hl,$F808
  ld (g2),hl
  ld hl,$FE08
  ld (g1),hl
; ld hl,$9600		;top of the picture
  ld hl,(MEM_START)
  ld b,32
MPloop00:
  push bc
  ld b,8
MPloop0:
  push bc
  ld b,8
MPloop1:
  push bc
  ld a,(bits)
  and (hl)
  ld c,a
  push hl
  ld de,16
  add hl,de
  ld a,(bits)
  and (hl)
  rlca
  rlca
  ld b,a
  rlc c
  rlc c
  call addbits
  ld a,e
  cp 3
  jr c,nodec
  dec e
nodec:
  bit 0,e
  jr z,skip0
  ld hl,(g2)
  ld a,(bits+1)
  or (hl)
  ld (hl),a
skip0:
  bit 1,e
  jr z,skip1
  ld hl,(g1)
  ld a,(bits+1)
  or (hl)
  ld (hl),a
skip1:
  pop hl
  pop bc
  ld a,5
  cp b
  jr nz,skipnext
  inc hl
skipnext:
  ld a,(bits)
  rrca
  rrca
  ld (bits),a
  ld a,(bits+1)
  rrca
  ld (bits+1),a
  djnz MPloop1
  pop bc
  push hl
  ld hl,(g1)
  inc hl
  ld (g1),hl
  ld hl,(g2)
  inc hl
  ld (g2),hl
  pop hl
  inc hl
  djnz MPloop0
  push hl
  ld de,8
  ld hl,(g1)
  add hl,de
  ld (g1),hl
  ld hl,(g2)
  add hl,de
  ld (g2),hl
  pop hl
  pop bc
  ld de,16
  add hl,de
  dec b
  xor a
  cp b
  jp nz,MPloop00
  ei
  ret

addbits:
  ld d,1
  ld e,0
ABloop:
  ld a,d
  and b
  jr z,nobits
  ld a,1
  add a,e
  ld e,a
nobits:
  ld a,d
  and c
  jr z,nobits2
  ld a,1
  add a,e
  ld e,a
nobits2:
  rlc d
  jr nc,ABloop
  ret

g1:
.dw 0
g2:
.dw 0
bits:
.db 0,0
tempx2:
.db 0,0



Clear$F600:
  ld hl,$F600
  push hl
  pop de
  inc de
  ld (hl),0
  ld bc,1023
  ldir
  ret


EndGray:
 res 2,(iy+$23)
 ld a,$3C
 out (0),a
 ret


ResumeGray:
 set 2,(iy+$23)
 ret


StartGray:
 res 2,(iy+$23)	;turn user int off so it won't get called by
				;accident before we're ready
clear_int:		;I always clear the interrupt for neatness (mainly for debugging)
 ld hl,$d2fd	;point hl to interrupt RAM
 ld (hl),$5A	;$5A is the standard checksum for a blank interrupt
 inc hl			;point hl one byte forward
 ld (hl),0		;clear the next byte
 ld de,$d2ff	;point de to the byte after hl
 ld bc,198		;we have to clear 198 bytes (of 200) since we already did the 1st 2
 ldir			;clear it out

 ld hl,int				;hl point to the begining of the program
 ld de,_user_int_ram+1	;de pionts to where the program is to be loaded
 ld bc,int_end-int		;bc is the length of the program to be sent
 ldir					;copies it

 ld a,(_user_int_ram+1)			;this sets up checksum byte - 
 ld hl,_user_int_ram+($28*1)	;we need to add the 1st bite with another one
 add a,(hl)						;every 40 bytes and store it in the...
 ld hl,_user_int_ram+($28*2)
 add a,(hl)
 ld hl,_user_int_ram+($28*3)
 add a,(hl)
 ld hl,_user_int_ram+($28*4)
 add a,(hl)
 ld hl,_user_int_ram+($28*5)
 add a,(hl)
 ld (_user_int_ram),a			;first byte of the interrupt area

 set 2,(iy+$23)			;turn on the interrupt
 ret


int:
 push af
 push hl
 ld hl,counter
 dec (hl)
 jr nz,EndIntRoutine	;we only want to change the video mem once every 2 interrupts
 ld (hl),2
 inc hl
 ld a,(hl)
 cp 6				;5 pages in page_order
 jr nz,keepgoing
 ld (hl),1
keepgoing:
 ld b,(hl)
 inc (hl)
findpage:
 inc hl
 djnz findpage
 ld a,(Last)
 cp (hl)
 jr z,EndIntRoutine
 ld a,(hl)
 ld (Last),a
 out (0),a
EndIntRoutine:
 pop hl
 pop af
 ret
int_end:


Last:
	.db 0
counter:
	.db 4
page_number:
	.db 1
page_order:
;gray 4 (use 5)
	.db $3C,$36,$3C,$36,$3C

